VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "User-Defined Event Test"
   ClientHeight    =   2115
   ClientLeft      =   1140
   ClientTop       =   1515
   ClientWidth     =   4035
   ControlBox      =   0   'False
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   2115
   ScaleWidth      =   4035
   Begin VB.CommandButton cmdFont 
      Caption         =   "Font Size"
      Height          =   495
      Left            =   3120
      TabIndex        =   4
      Top             =   1560
      Width           =   735
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "&Cancel"
      Enabled         =   0   'False
      Height          =   435
      Left            =   1500
      TabIndex        =   1
      ToolTipText     =   "Cancel a running task"
      Top             =   1020
      Width           =   1035
   End
   Begin VB.CommandButton cmdGo 
      Caption         =   "&Go"
      Default         =   -1  'True
      Height          =   435
      Left            =   120
      TabIndex        =   0
      ToolTipText     =   "Start the task"
      Top             =   1020
      Width           =   1035
   End
   Begin VB.CommandButton cmdExit 
      Cancel          =   -1  'True
      Caption         =   "E&xit"
      Height          =   435
      Left            =   2820
      TabIndex        =   2
      ToolTipText     =   "Terminate the application"
      Top             =   1020
      Width           =   1035
   End
   Begin VB.Label lblPercentDone 
      Alignment       =   2  'Center
      Caption         =   "0"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   780
      TabIndex        =   3
      Top             =   300
      Width           =   2475
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Based on Warren Bedell's Test4 Event example

'First attempt at modification to handle multiple objects
'Wouldn't it be nice if you could create object arrays
'    for variables declared WithEvents

Option Explicit

'You can't do this - VB takes away the array subscripts!
'Private WithEvents foTest(1 to 2) As CEventTest

'You CAN do this - BUT you must eliminate WithEvents
'Private foTest(1 To 2) As CEventTest

'Here is the problem. If you create multiple objects
'WithEvents, then you have to give them individual names,
'so each Event subroutine has a unique name!
Private WithEvents foTest1 As CEventTest
Attribute foTest1.VB_VarHelpID = -1

Private fbCancel(1 To 2)             As Boolean

Private Sub cmdCancel_Click()

    fbCancel(1) = True

End Sub

Private Sub cmdExit_Click()

    Unload Me

End Sub

Private Sub cmdFont_Click()
    
    Call ChgFontSize(Me)
    
End Sub

Private Sub cmdGo_Click()

    fbCancel(1) = False
    lblPercentDone.Caption = "0%"
    
    DoEvents

    Me.MousePointer = vbArrowHourglass
    cmdCancel.Enabled = True
    cmdGo.Enabled = False
    cmdExit.Enabled = False
    DoEvents

    'Start a long running process in
    'the class module
    
    foTest1.LongTask 5, 0.5

    cmdExit.Enabled = True
    cmdGo.Enabled = True
    cmdCancel.Enabled = False
    Me.MousePointer = vbDefault
    DoEvents

    If Not fbCancel(1) Then
        lblPercentDone.Caption = "Done"
    Else
        lblPercentDone.Caption = "Canceled"
    End If

End Sub


Private Sub foTest1_PercentDone(ByVal afPercent As Single, _
    abCancel As Boolean)

    'This event is raised by the CEventText
    'class, which returns the Percent value,
    'which we display

    'We also pass the value of Cancel back to
    'the class in the second argument. This will
    'be true if we press the Cancel button

    lblPercentDone.Caption = CInt(100 * afPercent) & "%"

    DoEvents

    abCancel = fbCancel(1)

End Sub


Private Sub Form_Terminate()

    Set foTest1 = Nothing

End Sub

Private Sub Form_Initialize()
    
    Set foTest1 = New CEventTest

End Sub

